/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_RIGHTROADEDGE_H
#define DPC_IMPL_TYPE_RIGHTROADEDGE_H

#include "impl_type_uint32.h"
#include "dpc/impl_type_array_rmrdedgergtgeometry_6.h"
#include "impl_type_boolean.h"
#include "impl_type_uint8.h"

namespace dpc {
struct RightRoadEdge {
    ::UInt32 rm_rdedgergt_id{ 0U };
    ::dpc::array_RMRdEdgeRgtgeometry_6 rm_rdedgergt_geometry{};
    ::Boolean rm_rdedgergt_edoutview{ false };
    ::UInt8 rm_rgtrdedgesnsrsource{ 0U };

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(rm_rdedgergt_id);
        fun(rm_rdedgergt_geometry);
        fun(rm_rdedgergt_edoutview);
        fun(rm_rgtrdedgesnsrsource);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(rm_rdedgergt_id);
        fun(rm_rdedgergt_geometry);
        fun(rm_rdedgergt_edoutview);
        fun(rm_rgtrdedgesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("rm_rdedgergt_id", rm_rdedgergt_id);
        fun("rm_rdedgergt_geometry", rm_rdedgergt_geometry);
        fun("rm_rdedgergt_edoutview", rm_rdedgergt_edoutview);
        fun("rm_rgtrdedgesnsrsource", rm_rgtrdedgesnsrsource);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("rm_rdedgergt_id", rm_rdedgergt_id);
        fun("rm_rdedgergt_geometry", rm_rdedgergt_geometry);
        fun("rm_rdedgergt_edoutview", rm_rdedgergt_edoutview);
        fun("rm_rgtrdedgesnsrsource", rm_rgtrdedgesnsrsource);
    }

    friend bool operator==(const ::dpc::RightRoadEdge& lhs, const ::dpc::RightRoadEdge& rhs) noexcept
    {
        return (lhs.rm_rdedgergt_id == rhs.rm_rdedgergt_id) && (lhs.rm_rdedgergt_geometry == rhs.rm_rdedgergt_geometry) && (lhs.rm_rdedgergt_edoutview == rhs.rm_rdedgergt_edoutview) && (lhs.rm_rgtrdedgesnsrsource == rhs.rm_rgtrdedgesnsrsource);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_RIGHTROADEDGE_H
